'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _location = require('rootr/lib/location');

var _location2 = _interopRequireDefault(_location);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isLeftClickEvent(event) {
  return event.button === 0;
}

function isModifiedEvent(event) {
  return !!(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
}

var Link = _react2.default.createClass({
  displayName: 'Link',
  handleClick: function handleClick(event) {

    if (this.props.onClick) this.props.onClick(event);

    if (event.defaultPrevented) return;

    if (isModifiedEvent(event) || !isLeftClickEvent(event)) return;

    if (this.props.stopPropagation) event.stopPropagation();
    event.preventDefault();

    this.props.action ? this.props.action(event) : _location2.default.open(this.props.to);
  },
  render: function render() {

    if (this.props.type === 'button') {
      return _react2.default.createElement(
        'button',
        { disabled: this.props.disabled, className: this.props.className, style: this.props.style, onClick: this.handleClick },
        this.props.children
      );
    }

    return _react2.default.createElement(
      'a',
      { disabled: this.props.disabled, className: this.props.className, style: this.props.style, onClick: this.handleClick, href: this.props.to },
      this.props.children
    );
  }
});

exports.default = Link;
module.exports = exports['default'];